package require mclistbox 1.02
catch {namespace import mclistbox::*}


proc PutHelp {args} {
   set msg [lindex $args 0]
   set tag [lindex $args 1]
  .main.nb.f4.help config -state normal
  .main.nb.f4.help insert end "$msg\n" $tag
  .main.nb.f4.help config -state disabled

}


proc TabHelp {w} {

  text $w.help -background white -height 18 -width 63 -selectforeground white -selectbackground blue -yscrollcommand "$w.scroll set"
  scrollbar $w.scroll -width 10 -command "$w.help yview"

  $w.help tag configure title -foreground blue -font {Helvetica 12 bold}
  $w.help insert end ""

  grid config $w.help  -column 0 -row 0 \
  -columnspan 1 -rowspan 1 -sticky "snew" -pady 5
  grid config $w.scroll  -column 1 -row 0 \
  -columnspan 1 -rowspan 1 -sticky "snew" -pady 5

  $w.help config -state disabled
  PutHelp ""
  PutHelp "What is XSatellite?" title
  PutHelp ""
  PutHelp "XSatellite is a GUI for the linux version of AudioGalaxy Satellite.\
  The program commmunicates with AGSatellite and gets the informations\
  about your file transfers. "
  PutHelp "XSatellite loads AGSatellite on startup and waits for incoming transfers."
  PutHelp ""
  PutHelp "Configuration" title
  PutHelp ""
  PutHelp "In order to use the program you need to have a login, you can get your username and password\
  at http://www.audiogalaxy.com, if you have used AGSatellite then you already have your login"
  PutHelp "Once you have your login configure the client and set your share directory, this is the directory\
  where you have the files to share with the other users and it's also where the new files will be saved in."
  PutHelp "Note that any time you change your login information or your share directory you need to restart\
  AGSatellite for the changes to take effect (the program will ask you to do it when you save the changes)."
  PutHelp ""
  PutHelp "File Transfers" title
  PutHelp ""
  PutHelp "You'll notice that informations for SEND transfers get updated every so often and not  continuously\
  like those for GET transfers. This is because with GET transfers the program can get the transfer info also by examinating\
  the file content, with SEND transfers the only informations are those coming from AGSatellite."
  PutHelp "If you use the \"play file when transfer is complete\" option remember that the file will be played when the connection\
  with the sender is actually closed and not just when the transfer is finished."
  PutHelp ""
  PutHelp "Searches:" title
  PutHelp ""
  PutHelp "You can use the search Tab to search for files, just like you have done up to now from the AudioGalaxy website.
  Xsatellite connects and logins to the site when it starts up, when you perform a search the query is sent like a html get request,
  and the returning data is formatted back as a list of songs. You can use the \"NEXT PAGE\" button to jump to the next page of
  the list of songs that have been found; for song searches the next page button jumps 10 records forward, for artist searches 25 records.
  To queue a song and download it just click on the \"QUEUE\" button or double-click on the song name in the list.
  This version doesn't let you choose the song version, but I'll add this feature in the next version."

}


proc TabSearch {w} {

   frame $w.s
   mclistbox $w.s.search \
	    -bd 0 \
	    -height 8 \
	    -columnrelief flat \
	    -labelanchor w \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -background white \
	    -selectforeground white \
	    -selectbackground blue \
	    -labelborderwidth 2 \
	    -fillcolumn name \
	    -yscrollcommand [list $w.s.sscroll set]

   $w.s.search column add band -label "Band" -width 25
   $w.s.search column add song -label "Song" -width 30
   $w.s.search column add id -label "ID" -width 10
   scrollbar $w.s.sscroll -command [list $w.s.search yview] -width 10

   $w.s.search label bind band <ButtonPress-1> "sort %W band"
   $w.s.search label bind song <ButtonPress-1> "sort %W song"
   $w.s.search label bind id <ButtonPress-1> "sort %W id"

   frame $w.f
   label $w.f.search -text "Search for:"
   entry $w.f.entry -text "" -background white -selectforeground white -selectbackground blue
   frame $w.bottom
   button $w.bottom.next -font {-size 10} -text "NEXT PAGE" -command "Search 0"
   button $w.bottom.queue -font {-size 10} -text "QUEUE SONG" -command "RequestSong $w.s.search"
   pack $w.bottom.next $w.bottom.queue -side left
   bind $w.f.entry <Return> "Search 1"
   pack $w.f.search -side left
   pack $w.f.entry -side right -fill x -expand y
   pack $w.s.search -fill both -expand y -side left
   pack $w.s.sscroll -side left -fill y -side right

   grid config $w.f  -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snew" -padx 5 -pady 5
   grid config $w.s  -column 0 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "snew" -padx 5
   grid config $w.bottom -column 0 -row 2 \
   -columnspan 1 -rowspan 1 -sticky "snew" -padx 5 -pady 5

   grid columnconfigure $w 0 -weight 1
   grid columnconfigure $w 0 -weight 1
   grid rowconfigure $w 1 -weight 1
   focus $w.f.entry
   bind $w.s.search <Double-1> "RequestSong $w.s.search"
}

proc TabTransfers {y} {
   global gui me

   frame $y.f
   frame $y.bar

   button $y.bar.go -font {-size 10} -text "Audiogalaxy.com" -command "GoToUrl $me(url)"
   button $y.bar.del -font {-size 10} -text "REMOVE COMPLETED" -command "RemoveCompleted"
   button $y.bar.init -font {-size 10} -text "RESTART SATELLITE" -command "SaveSettings; Init"
   button $y.bar.play -font {-size 10} -text "PLAY" -command {PlayMp3 ""}
   set gui(play) $y.bar.play
   pack $y.bar.go $y.bar.del $y.bar.init $y.bar.play -side left -pady 5

   set w "$y.f"
   mclistbox $w.tf \
	    -bd 0 \
	    -height 8 \
	    -columnrelief flat \
	    -labelanchor w \
	    -columnborderwidth 0 \
	    -selectmode browse \
	    -background white \
	    -selectforeground white \
	    -selectbackground blue \
	    -labelborderwidth 2 \
	    -fillcolumn name \
	    -selectcommand "Selection" \
	    -yscrollcommand [list $w.tfscroll set]

   $w.tf column add type -label "Type" -width 7
   $w.tf column add file -label "Filename" -width 35
   $w.tf column add size -label "Size" -width 10
   $w.tf column add kps -label "KPS" -width 8
   $w.tf column add per -label "%" -width 5 

   $w.tf label bind type <ButtonPress-1> "sort %W type"
   $w.tf label bind file <ButtonPress-1> "sort %W file"
   $w.tf label bind size <ButtonPress-1> "sort %W size"
   $w.tf label bind kps <ButtonPress-1> "sort %W kps"
   $w.tf label bind per <ButtonPress-1> "sort %W per"

   bind $w.tf <Double-1> {PlayMp3 ""}

   scrollbar $w.tfscroll -command [list $w.tf yview] -width 10
   scrollbar $w.stscroll -width 10 -command "$w.status yview"

   text $w.status -height 4 -background white -yscrollcommand "$w.stscroll set" -state disabled -selectforeground white -selectbackground blue
   grid config $w.tf  -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $w.tfscroll  -column 1 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "sne"
   grid config $w.status  -column 0 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $w.stscroll  -column 1 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "sne"

   grid columnconfigure $w 0 -weight 1
   grid rowconfigure $w 0 -weight 1
   pack $y.f -padx 5 -pady 5 -side top
   pack $y.bar -padx 5 -side left
   set gui(status) $w.status
   set gui(tf) $w.tf
}


proc TabShares {w} {
global c flistw me

framebox $w.shares -text "Share directory:"
set win $w.shares.c

frame $win.hz -relief raised -borderwidth 1 -cursor sb_h_double_arrow -width 4
canvas $win.flist -background white -height 180 -width 410 -borderwidth 1 -relief sunken -yscrollcommand "$win.fscrolly set"
flist::Show $win.flist
scrollbar $win.fscrolly -width 10 -command "$win.flist yview"
entry $win.path -borderwidth 1 -width 1 -selectforeground white -selectbackground blue -background white

grid $win.path     -column 0 -row 1 -sticky nsew
grid $win.flist    -column 0 -row 2 -sticky nsew
grid $win.fscrolly -column 1 -row 1 -sticky ns -rowspan 2
grid $win.hz       -column 2 -row 1 -sticky ns -rowspan 2


set flistw ""

bind $win.hz <Button-1> {
global flistw flistow
%W configure -background white
set flistw %X
set flistow  [expr [winfo width .main.nb.f3.shares.c.flist]-4]
}

bind $win.hz <ButtonRelease> {
global flistw
set flistw ""
%W configure -background white
}

bind $win.hz <Enter> " %W configure -background white "
bind $win.hz <Leave> " %W configure -background white "

bind $win.hz  <Motion> {
global flistw flistow c
if {$flistw!=""} {
	set y [expr $flistow + (%X - $flistw)]
	if {$y>0} {
	.main.nb.f3.shares.c.flist configure -width $y
	}
 	}
}

bind $win.path <Return> {
}



   grid config $w.shares -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snew"

   grid columnconfigure $w 0 -weight 1
   grid rowconfigure $w 0 -weight 1

}


proc TabSettings {w} {
   global me gui

   framebox $w.user -text "Login:"
   framebox $w.files -text "Files:"
   framebox $w.settings -text "Settings:"
   frame $w.bar


   checkbutton $w.settings.c.autoremove -selectcolor gray -text "automatically remove complete transfers" -variable me(autoremove)
   checkbutton $w.settings.c.autoplay -selectcolor gray -text "play file when transfer is complete" -variable me(autoplay)
   checkbutton $w.settings.c.notify  -selectcolor gray -text "notify transfer completion with sound" -variable me(notify)
   button $w.bar.save -font {-size 10} -text "SAVE" -command "AskSaveSettings"
   button $w.bar.reload -font {-size 10} -text "RELOAD" -command "LoadSettings"
   pack $w.bar.save $w.bar.reload -side left -pady 5

   label $w.user.c.luser -text "username"
   label $w.user.c.lpass -text "password"
   entry $w.user.c.user -width 12 -textvariable me(user) -background white -selectforeground white -selectbackground blue
   entry $w.user.c.pass -width 12 -textvariable me(pass) -background white -selectforeground white -selectbackground blue

   label $w.files.c.lshare -text "share directory"
   entry $w.files.c.share -width 12 -textvariable me(shares) -background white -selectforeground white -selectbackground blue
   button $w.files.c.bshare -font {-size 6} -text "..." -command "SetDirectory"
   label $w.files.c.lbrowser -text "browser"
   entry $w.files.c.browser -width 12 -textvariable me(browser) -background white -selectforeground white -selectbackground blue
   button $w.files.c.bbrowser -font {-size 6} -text "..." -command "SetFile browser"
   label $w.files.c.lmp3 -text "mp3 player"
   entry $w.files.c.mp3 -width 12 -textvariable me(player) -background white -selectforeground white -selectbackground blue
   button $w.files.c.bmp3 -font {-size 6} -text "..." -command "SetFile player"
   label $w.files.c.lurl -text "AudioGalaxy URL"
   entry $w.files.c.url -width 18 -textvariable me(url) -background white -selectforeground white -selectbackground blue

   grid config $w.user  -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $w.files  -column 1 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snew"
   grid config $w.settings  -column 0 -row 1 \
   -columnspan 2 -rowspan 1 -sticky "snew"
   grid config $w.bar  -column 0 -row 2 \
   -columnspan 2 -rowspan 1 -sticky "snew" -padx 10


   grid config $w.user.c.luser -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.user.c.user -column 1 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.user.c.lpass -column 0 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.user.c.pass -column 1 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "ne"

   grid config $w.files.c.lshare -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.share -column 1 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.bshare -column 2 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "ne"

   grid config $w.files.c.lbrowser -column 0 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.browser -column 1 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.bbrowser -column 2 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "ne"

   grid config $w.files.c.lmp3 -column 0 -row 2 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.mp3 -column 1 -row 2 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.bmp3 -column 2 -row 2 \
   -columnspan 1 -rowspan 1 -sticky "ne"


   grid config $w.files.c.lurl -column 0 -row 3 \
   -columnspan 1 -rowspan 1 -sticky "ne"
   grid config $w.files.c.url -column 1 -row 3 \
   -columnspan 2 -rowspan 1 -sticky "ne"

   grid config $w.settings.c.autoremove -column 0 -row 0 \
   -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $w.settings.c.autoplay -column 0 -row 1 \
   -columnspan 1 -rowspan 1 -sticky "snw"
   grid config $w.settings.c.notify -column 0 -row 2 \
   -columnspan 1 -rowspan 1 -sticky "snw"

   grid columnconfigure $w 1 -weight 1
   grid rowconfigure $w 0 -weight 1
   grid rowconfigure $w 1 -weight 1

}

proc SetDirectory {} {
  global me
  set tmp [tk_chooseDirectory -initialdir $me(shares) -mustexist 1]
  if {$tmp!=""} {
    set me(shares) $tmp
  }
}

proc SetFile {filename} {
    global me
    set file [tk_getOpenFile -initialdir [pwd] -title "Select a file"]
    if {$file!=""} {
      set me($filename) $file

    }
}

proc sort {w id} {

    set data [$w get 0 end]
    set index [lsearch -exact [$w column names] $id]

    set result [lsort -index $index $data]

    $w delete 0 end

    eval $w insert end $result

}


proc xmenu {w args} {
  eval "menu $w $args -tearoff 0 -activeborderwidth 0 -activebackground blue -activeforeground white"
}


wm title . "$me(version)"

wm geometry . $me(geometry)
#wm maxsize . 511 381
wm maxsize . 511 400
wm minsize . 269 224
#wm iconbitmap . @gif/sat.bmp
frame .menubar -bd 2 -relief raised
menubutton .menubar.bfile -text "File" -underline 0 -menu .menubar.bfile.m
set m [xmenu .menubar.bfile.m]

set co [$m cget -background]

$m add command -image $i_bar -columnbreak 0 -hidemargin 1 -activeforeground $co -activebackground $co -foreground $co -background $co

button .menubar.logo -image $me(image) -relief flat -command "About"


pack .menubar.bfile -side left
pack .menubar.logo -side right
frame .main -bd 2 -relief groove


frame .status -bd 1 -relief flat
label .status.fsys -relief sunken -bd 2
label .status.fdat -relief sunken -bd 2
label .status.new -relief sunken -bd 2
label .status.version -relief flat -text $me(version)

pack .status.fsys .status.fdat .status.new -side left -fill x -expand y
pack .status.version -side right

grid config .menubar -column 0 -row 0 \
	-columnspan 1 -rowspan 1 -sticky "snew"
grid config .main    -column 0 -row 1 \
	-columnspan 1 -rowspan 1 -sticky "snew"
grid config .status  -column 0 -row 2 \
	-columnspan 1 -rowspan 1 -sticky "snew"


grid columnconfigure . 0 -weight 1
grid rowconfigure . 1 -weight 1

proc Selection {args} {
   global me
   set me(selection) $args

}

Notebook:create .main.nb -pages {Transfers Search Settings Shares Help}
TabTransfers [Notebook:frame .main.nb {Transfers}]
TabSettings [Notebook:frame .main.nb {Settings}]
TabShares [Notebook:frame .main.nb {Shares}]
TabHelp [Notebook:frame .main.nb {Help}]
TabSearch [Notebook:frame .main.nb {Search}]

$m add command -label "Restart satellite" -columnbreak 1 -command "SaveSettings; Init"
$m add command -label "Audiogalaxy.com" -command "GoToUrl $me(url)"
$m add separator
$m add command -label "Transfers" -command "Notebook:raise.page .main.nb 0"
$m add command -label "Search" -command "Notebook:raise.page .main.nb 1"
$m add command -label "Settings" -command "Notebook:raise.page .main.nb 2"
$m add command -label "Shares" -command "Notebook:raise.page .main.nb 3"
$m add command -label "Help" -command "Notebook:raise.page .main.nb 4"
$m add separator
$m add command -label "Quit" -command { Quit }


pack .main.nb -expand 1 -fill both -padx 1m -pady 1m
bind <Destroy> . "exec killall AGSatellite"
wm protocol . WM_DELETE_WINDOW "Quit"


proc About {} {
   global me
   set w ".about"
   if {[winfo exists $w]} {return}
   toplevel $w -class About
   wm title $w "About $me(version)"
   wm geometry $w +200+200
   wm resizable $w 0 0
   pack [frame $w.f -bd 2 -relief ridge] -side top -expand yes -fill both
   pack [button $w.ok -text "OK" -command "destroy $w"] -side bottom -pady 10
   button $w.f.saverio -relief flat -image $me(saverio)
   message $w.f.version -relief flat -width 200 -text "$me(version) \nby Saverio (saverio@kermit.it)\n\n\
   $me(program_url)"
   message $w.f.text -font {-size 10} -width 200 -relief flat -text "Sorry for the pic but if mIRC author can afford to put his pic\
   in the program.... we all can!"
   grid config $w.f.saverio -column 0 -row 0 -columnspan 1 -rowspan 2 -sticky "snw"	        	
   grid config $w.f.version -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky "snew"	        	
   grid config $w.f.text -column 1 -row 1 -columnspan 1 -rowspan 1 -sticky "sew"	        	
   wm transient $w .
   focus $w
   focus $w.ok
}


proc Quit {} {
  global me gui
  set msg "The are currently some file transfers in progress, are you sure you want to quit?"
  set transfers [$gui(tf) size]
  if {$transfers!=0} {
    set quit [tk_messageBox -icon question -message $msg -type okcancel]
    if {$quit=="cancel"} { return }
  }
  catch {exec killall AGSatellite &}
  if {$me(play_pid)!=""} {
    catch { exec kill -9 $me(play_pid) & }
  }
  SaveSettings
  exit
}

proc AskSaveSettings {} {
  SaveSettings
  set msg "If you changed your login or share directory the Satellite needs to\
  be restarted for the changes to take effect.\n\n Restart Satellite?"
  set save [tk_messageBox -icon question -message $msg -type okcancel]
  if {$save=="ok"} { Init }
}


if {$me(created)!=""} {

  set msg "The following files have been created:\n"
  for {set i 0} {$i < [llength $me(created)]} {incr i} {
     append msg "[lindex $me(created) $i]\n"
  }
  append msg "\nchange the default settings and click on the \"restart satellite\" button"
  tk_messageBox -icon warning -message $msg -type ok

}

