proc RequestSong {w} {
   set sel [$w curselection]
   if {$sel==""} {return}
   SearchState 0
   set line [$w get $sel]
   set songID [lindex $line end]
   set song "[lindex $line 0] - [lindex $line 1]"
   Request $songID [list $song]

}

proc QueueSong {songID song} {
  global me
    if {[catch {socket www.audiogalaxy.com 80} sock]} {
      tk_messageBox -icon error -message $sock
      return
    }
    fconfigure $sock -blocking 0
    fconfigure $sock -buffering line
    puts $sock "GET /satellite/queue.php?g=$songID&SID=$me(sID) HTTP/1.0\n\n"
    fileevent $sock readable "QueueResult $sock $songID [list $song]"
}

proc QueueResult {s songID song} {
    if {[eof $s]} {
      SearchState 1
      catch {close $s}
      return
    }
      set line [gets $s]
      if {[string match "*Duplicate Request*" $line]==1} {
        set err "The following song is already in your download queue:\n $song"
        catch {close $s}
        tk_messageBox -icon error -message $err
        SearchState 1
        return
      } elseif {[string match "*Song added*" $line]==1} {
        catch {close $f}
        tk_messageBox -icon info -message "Song added to search list:\n $song" -type ok
        SearchState 1
        return
      } elseif {[string match "*High Server Load*" $line]==1} {
        catch {close $f}
        set msg "Warning : High Server Load  Our Satellite servers are very loaded down today. You may become temporarily disconnected even though your Satellite is running properly. If this has happened to you, please be patient - your Satellite will re-connect when the server is available.  You might also want to try back after 7:00pm CDT when the load is usually lower."
        tk_messageBox -icon warning -message "$msg" -type ok
        SearchState 1
        return
      }

}

proc Login {} {
    global me
    if {[catch {socket www.audiogalaxy.com 80} me(sock)]} {
         msg "Couldn't login...retrying in 30 seconds..."
         SearchState 0
         after 30000 {
            Login
         }
         return
    }
    set me(sID) ""
    msg "Logging into www.audiogalaxy.com"

    fconfigure $me(sock) -blocking 0
    fconfigure $me(sock) -buffering line
    set login "loginUsername=$me(user)&loginPassword=$me(pass)"
    set url "/user/home.php"
    set l [string length $login]
    puts $me(sock) "POST $url HTTP/1.0"
    puts $me(sock) "Content-length: $l"
    puts $me(sock) "Content-type: application/x-www-form-urlencoded\n"
    puts $me(sock) "$login\n"
    set me(conn) 1
    fileevent $me(sock) readable "LoginGet $me(sock)"
}

proc Search {se} {
 global me
 if {$se==1} {
   set search [.main.nb.f1.f.entry get]
   if {$search==""} return
   regsub -all { } $search {+} search
   .main.nb.f1.s.search delete 0 end
   .main.nb.f1.f.entry delete 0 end

   set me(search) $search
   set me(offset) 0
   set searchstr "GET /list/searches.php?searchType=0&searchStr=$search HTTP/1.0\n\n"
 } else {
   .main.nb.f1.s.search delete 0 end
   .main.nb.f1.f.entry delete 0 end
   set search $me(search)
   if {$me(offset)==""} {return}
   if {$me(stype)} {
     set me(offset) [expr $me(offset)+10]
     set searchstr "GET /list/searches.php?searchType=0&searchStr=$search&offset=$me(offset) HTTP/1.0\n\n"
   } else {
     set me(offset) [expr $me(offset)+25]
     set searchstr "GET /list/artistInfo.php?&r=$me(artist)&offset=$me(offset) HTTP/1.0\n\n"
   }
 }

 if {[catch {socket www.audiogalaxy.com 80} sock]} {
        tk_messageBox -icon error -message "Cannot connect to AudioGalaxy website: $sock, reconnecting in 30 seconds."
         SearchState 0
         after 30000 {
            Login
         }
         return
 }

 fconfigure $sock -blocking 0
 fconfigure $sock -buffering line
 puts $sock $searchstr
 set s ""
 for {set i 0} {$i < [string length $search]} {incr i} {
   set c [string index $search $i]
   if {$c!="+"} {
     append s $c
   } else {
     append s "*"
   }
 }
 fileevent $sock readable "SearchResult $sock $s"
 SearchState 0
}


proc LoginGet {s} {
    global me
    if {[eof $s]} {
      catch {close $s}
      if {$me(sID)==""} {
         SearchState 0
         msg "Couldn't login...retrying in 30 seconds..."
         after 30000 {
            Login
         }
      } else {
         msg "Logged to www.audiogalaxy.com"
         SearchState 1
      }
    }
    if {[catch {gets $s} line]} {
      return
    }
    if {[string match "*Set-Cookie: SID=*;*" $line]==1} {
       set sID [lindex $line 1]
       set sID [string trimleft $sID "SID="]
       set sID [string trimright $sID ";"]
       set me(sID) $sID
    } elseif {[string match "*Login Failed*" $line]==1} {
       catch {close $s}
       SearchState 0
       set me(sID) ""
       msg "Login failed"
       tk_messageBox -icon error -message "Login Failed, check your username and password and restart" -type ok
       return
    }
}



proc Request {songID song} {
 global me
 if {$me(sID)==""} {return}
 set sock [socket www.audiogalaxy.com 80]
 fconfigure $sock -blocking 0
 fconfigure $sock -buffering line
 set search "/list/song.php?SID=$me(sID)&g=$songID"
 puts $sock "GET $search HTTP/1.0\n\n"
 fileevent $sock readable "RequestResult $sock $songID $song"
}

proc RequestResult {f songID song} {
    global me
    if {[eof $f]} {
      QueueSong $songID $song
      catch {close $f}
      return
    }
    set line [gets $f]
    set line [remove_html $line]"
}


proc SearchResult {f search} {
    global me
    if {[eof $f]} {
      SearchState 1
      catch {close $f}
      return
    }
    set line [gets $f]
    set line [remove_html $line]"
    set search [string trim $search "\{\}"]
    set osearch $search
    set search "*$search*"

    if {[string match "*@  HINT:*" $line]==1} {
       GetSongs $line $search

    } elseif {[string match $search $line]==1} {
      if {$me(songID)!=""} {
        set line [string trimleft $line "\t "]
        set j [string first "@  @" $line]
        set band [string range $line 4 [expr $j-1]]
        set song [string range $line [expr $j+9] end]
        set j [string first "@  @  @  @" $song]
        set song [string range $song 0 [expr $j-1]]
        set song [string trim $song " "]
        regsub -all { @ } $song { } song
        regsub -all { @ } $band { } band
        set band [string trim $band " "]
        if {[string first "Message Board" $song]!=-1||$me(songID)=="To"} {return}
        if {$band!=""||$song!=""} {
          .main.nb.f1.s.search insert end [list "$band" "$song" "$me(songID)"]
          set me(stype) 1
        }
        set me(songID) ""
      }
    }
}

proc GetSongs {line search} {
  global me
  set me(stype) 0
  set j 1
  set line [list $line]
  set line [split $line "@"]
  for {set i 0} {$i < [llength $line] } {incr i} {
    set item [lindex $line $i]
    if {[string match "*songIDs?$j?.songID = *" $item]==1} {
       set songID [lindex $item 5]
       set pv [string first ";" $songID]
       set songID [string range $songID 0 [expr $pv-1]]
       incr j
    } elseif {[string match $search $item]==1} {
       set item [split $item "-"]
       set band [lindex $item 0]
       set song [lindex $item 1]
       if {$band==""&&$song==""} {return}
       .main.nb.f1.s.search insert end [list "$band" "$song" "$songID"]
    }
  }
}

#artistInfo.php?&r="
proc remove_html {html} {
     global me

     if {[string first "artistInfo.php" $html]!=-1} {
        set i [string first "artistInfo.php?&r=" $html]
        set l [string range $html $i end]
        set j [string first "r=" $l]
        set m [string range $l [expr $j+2] end]
        set l [string first "&" $m]
        set artist [string range $m 0 [expr $l-1]]
        if {[string is integer -strict $artist]} {
          set me(artist) $artist
        }
     }
     regsub -all {<[^>]*>} $html { } html
     regsub -all {&nbsp;} $html { } html
     regsub -all {   } $html { @ } html
     if {[string match "*songIDs*.songID = *;*" $html]==1} {
       set me(songID) [string trimright [lindex $html 2] ";"]
     }
     return $html

}

proc SearchState {b} {
 if {$b} {
  .main.nb.f1.f.entry config -state normal
  .main.nb.f1.bottom.next config -state normal
  .main.nb.f1.bottom.queue config -state normal
  .main.nb.f1.f.entry config -background white
  focus .main.nb.f1.f.entry
 } else {
  .main.nb.f1.f.entry config -state disabled
  .main.nb.f1.bottom.next config -state disabled
  .main.nb.f1.bottom.queue config -state disabled
  .main.nb.f1.f.entry config -background gray
 }
}


SearchState 0