
array set me ""
array set gui ""
array set tf ""
array set files ""


set me(path) [pwd]

set files(account) "$me(path)/account.txt"
set files(shares) "$me(path)/shares.txt"
set files(config) "$env(HOME)/.xsatrc"
set files(satellite) "$me(path)/Satellite/AGSatellite"

set me(version) "XSatellite - v 0.21"
set me(program_url) "http://xsatellite.sourceforge.net"
set me(file) "$me(path)/logv520.txt"
set me(notify_wav) "$me(path)/wav/file.wav"
set me(pos) 0
set me(id) 0
set me(sock) ""
set me(conn) 0
set me(logged) 0
set me(update) ""
set me(play_pid) ""
set me(selection) ""
set me(created) ""
set me(sID) ""
set me(songID) ""
set me(search) ""
set me(offset) ""
set me(stype) 1
set me(artist) ""
source tcl/settings.tcl
LoadSettings
source tcl/notebook.tcl
source tcl/mclistbox.tcl
source tcl/framebox.tcl
source tcl/images.tcl
source tcl/flist.tcl
source tcl/gui.tcl
source tcl/msgbox.tcl
source tcl/search.tcl

proc ReadLog {} {
 global me

 after 500 { ReadLog }
 if {[catch {open $me(file) r} me(sock)]} {
   return
 }

 if {[catch {seek $me(sock) $me(pos) start} err]} {
   puts "error seeking file: $err"
   return
 }

 fconfigure $me(sock) -blocking 0
 fconfigure $me(sock) -buffering line

 fileevent $me(sock) readable [list HandleMSG $me(sock)]
 catch {TransferUPDATE}
}


proc Init {} {
 global me gui tf files

 cd $me(path)
 catch { exec killall AGSatellite}
 catch { exec rm -rf $me(file)}
 if {[catch {exec $files(satellite) &} err]} {
   tk_messageBox -icon error -message $err
   return
 }
 set me(pos) 0
 set me(id) 0
 set me(update) ""
 set me(play_pid) ""
 set me(selection) ""
 set me(created) ""
 array unset tf
 $gui(tf) delete 0 end
 $gui(status) config -state normal
 $gui(status) delete 0.1 end
 $gui(status) config -state disabled
 msg "AGSatellite started!"
 after 2000 {Login}
}





proc HandleMSG {sock} {
 global me
 if {[eof $sock]} {
   catch {
     close $sock
   }
   return
 }
 set b [read $sock]
 incr me(pos) [string length $b]

 if {$b!=""} {
   set msgs [split $b \n]
   foreach line $msgs  {
     if {[string first "<SERVERMSG>" $line]==0} {
        ServerMSG $line
     } elseif {[string first "<CLIENTMSG>" $line]==0} {
        ClientMSG $line
     } elseif {[string match "X: * Y: * newfiles: *" $line]==1} {
        SetStatus $line
     } elseif {[string match "Number in fdatabase: *   Number in filesystem: *" $line]==1} {
        SetFileNumber $line
     } elseif {[string match "AFTER COMPARE Number in fdatabase: *   Number in filesystem: *" $line]==1} {
        SetFileNumber $line
     }
   }
 }

}

proc ClientMSG {msg} {

  if {[string match "<CLIENTMSG>file completed! port: * fileName: * id: *" $msg]==1} {
     catch {TransferCOMPLETE $msg}
  } elseif {[string match "<CLIENTMSG>Telling server connection closed with error * on port: * fileName: * id: *" $msg]==1} {
     catch {TransferERROR $msg}
  }
}


proc ServerMSG {msg} {

 if {[string match "<SERVERMSG>Transfer on port: * ip: *.*.*.* fileName: * fileID: * fileSize: *" $msg]==1} {
   TransferADD $msg
 } elseif {[string match "<SERVERMSG>Server says to start transfer, using index: *" $msg]==1} {
   TransferID $msg
 } elseif {[string match "<SERVERMSG>Receiving file: START FILE POSITION: * id *" $msg]==1} {
   catch {TransferSTART $msg}
 } elseif {[string match "<SERVERMSG>SENDING FILE" $msg]==1} {
   TransferSEND
 } elseif {[string match "<SERVERMSG>FILE PATH: * id: *" $msg]==1} {
   TransferPATH $msg
 } elseif {[string match "<SERVERMSG>id: * File: * bytes/sec   filePtr: *" $msg]==1} {
   catch {TransferPTR $msg}
 }
 # $gui(status) insert end "$msg\n"
}


proc TransferERROR {msg} {
   global tf gui me
   set id [lindex $msg end]
   set filename $tf($id,filename)
   if {$filename=="proxy test"} {return}
   set index [GetRowByFilename $filename]
   if {[lindex $msg 6]==0} {
     if {$tf($id,type)=="SEND"} {
       TransferDEL $id
       set index [GetRowByFilename $filename]
       set kps [lindex [$gui(tf) get $index] 3]
       $gui(tf) delete $index $index
       $gui(tf) insert $index [list $tf($id,type) "$tf($id,filename)" " [FormatSize $tf($id,size)]" " $kps" 100%]
       if {$me(autoremove)} {$gui(tf) delete $index $index}
       msg "Transfer of $filename ([FormatSize $tf($id,size)]) completed. Id $id"
       if {$me(notify)} {
         catch { exec play $me(notify_wav) & }
       }
     }
     return
   } else {
     msg "Transfer of $filename interreupted: error [lindex $msg 6]. Closing connection with $tf($id,ip) ($tf($id,port))"
   }

   $gui(tf) delete $index $index
   TransferDEL $id
}

proc TransferPTR {msg} {
  global tf gui
  set id [lindex $msg 1]
  if {$tf($id,type)=="GET"} {return}
  set l [llength $msg]
  set index [GetRowByFilename "$tf($id,filename)"]
  set size [file size $tf($id,path)]

  set bps [lindex $msg [expr $l-4]]
  set kps1 [expr $bps/1024]
  set kps2 [expr $bps%1024]

  set per [proportion $tf($id,size) [lindex $msg end]]

  set sel [$gui(tf) curselection]

  $gui(tf) delete $index $index
  $gui(tf) insert $index [list $tf($id,type) "$tf($id,filename)" " [FormatSize $tf($id,size)]" " $kps1.$kps2" $per%]

  set $tf($id,time) [clock seconds]
  set $tf($id,cursize) [lindex $msg end]

  $gui(tf) selection set $sel $sel


}


proc GetRowByFilename {filename} {
  global gui

  set filelist ""
  for {set i 0} {$i < [$gui(tf) size]} {incr i} {
    lappend filelist [lindex [$gui(tf) get $i] 1]
  }
  set index [lsearch $filelist $filename]
  return $index
}

proc RemoveCompleted {} {
  global gui
  for {set i 0} {$i < [$gui(tf) size]} {incr i} {
    set per [lindex [$gui(tf) get $i] 4]
    if {$per=="100%"} {
       $gui(tf) delete $i $i
    }
  }

}

proc TransferCOMPLETE {msg} {
  global me tf gui
  set id [lindex $msg end]
  set filename $tf($id,filename)
  msg "Transfer of $filename ([FormatSize $tf($id,size)]) completed. Id $id"

  set index [GetRowByFilename $filename]
  set kps [lindex [$gui(tf) get $index] 3]

  if {$me(autoremove)} {
    $gui(tf) delete $index $index
  }

  if {$me(notify)} {
    catch { exec play $me(notify_wav) & }
  }

  if {$me(autoplay)} {
     exec $me(player) "$me(shares)/$tf($id,filename)" &
  }

  TransferDEL $id
}


proc TransferSEND {} {
  global me tf gui
  set id $me(id)
  set tf($id,type) "SEND"
  msg "Sending $tf($id,filename) ([FormatSize $tf($id,size)]). File id $id"
  $gui(tf) insert end [list SEND "$tf($id,filename)" " [FormatSize $tf($id,size)]"]
  set tf($id,time) [clock seconds]
  set tf($id,cursize) 0
}

proc TransferSTART {msg} {
  global tf gui
  set id [lindex $msg end]
  if {$tf($id,filename)=="proxy test"} {
  } else {
    set tf($id,type) "GET"
    msg "Receiving $tf($id,filename) ([FormatSize $tf($id,size)]) starting from position ([FormatSize [lindex $msg 5]]). File id $id"
    $gui(tf) insert end [list GET "$tf($id,filename)" " [FormatSize $tf($id,size)]"]
    set tf($id,time) [clock seconds]
    set tf($id,cursize) [lindex $msg 5]

  }
}

proc TransferPATH {msg} {
  global tf me
  set l [llength $msg]
  set id [lindex $msg end]
  set fpath [lrange $msg 2 [expr $l-3]]
  set tf($id,path) $fpath
  if {[lsearch $me(update) $id]==-1} {
   lappend me(update) $id
  }
}


proc TransferUPDATE {} {
 global tf gui me
 for {set i 0} {$i < [llength $me(update)]} {incr i} {
  set id [lindex $me(update) $i]
  set complete 0
  if {![file exists $tf($id,path)]} {
    if {[file exists "$me(shares)/$tf($id,filename)"]} {
       if {[file size "$me(shares)/$tf($id,filename)"]==$tf($id,size)} {
         set complete 1
       } else {
         continue
       }
    } else {
      continue
    }
  }

  set index [GetRowByFilename "$tf($id,filename)"]
  set type [lindex [$gui(tf) get $index] 0]
  if {$type=="SEND"} {continue}
  if {$complete==1} {
    set size $tf($id,size)
  } elseif {[catch {file size $tf($id,path)} size]} {
    continue
  }
  set timediff [expr [clock seconds]-$tf($id,time)]
  if {$timediff==0} {return}
  set sizediff [expr $size-$tf($id,cursize)]
  set bps [expr $sizediff/$timediff]
  set kps1 [expr $bps/1024]
  set kps2 [expr $bps%1024]
  set per [proportion $tf($id,size) $size]

  set sel [$gui(tf) curselection]
  set oldsize [$gui(tf) size]
  $gui(tf) delete $index $index
  set newsize [$gui(tf) size]
  incr newsize
  if {$oldsize==$newsize} {
    $gui(tf) insert $index [list $tf($id,type) "$tf($id,filename)" " [FormatSize $tf($id,size)]" " $kps1.$kps2" $per%]
    if {$complete==1} {
      TransferDEL $id
      continue
    }
  } else {
    TransferDEL $id
    continue
  }

  if {$tf($id,size)==$size} {
    TransferDEL $id
    continue
  }

  set $tf($id,time) [clock seconds]
  set $tf($id,cursize) $size

  catch {
    if {$index==$sel} {$gui(tf) selection set $sel $sel}
  }
 }

}

proc TransferDEL {id} {
    global me
    set newls ""
    for {set j 0} {$j < [llength $me(update)]} {incr j} {
      set elem [lindex $me(update) $j]
      if {$elem!=$id} {lappend newls $elem}
    }
    set me(update) $newls
}

proc TransferID {msg} {
  global me
  set me(id) [lindex $msg end]
}

proc TransferADD {msg} {
  global me tf

  set id $me(id)
  set l [llength $msg]
  set filename [lrange $msg 7 [expr $l-5]]
  set size [lindex $msg end]
  set port [lindex $msg 3]
  set ip [lindex $msg 5]
  if {$filename=="proxy test"} {
    msg "Proxy test on $ip ($port)"
  } else {
    msg "Adding transfer for file $filename ([FormatSize $size]) on $ip ($port) with id $id"
  }
    set tf($id,filename) $filename
    set tf($id,size) $size
    set tf($id,ip) $ip
    set tf($id,port) $port

}


proc GoToUrl {url} {
  global me
  if {[catch {exec $me(browser) $url &} err]} {
     tk_messageBox -icon error -message $err
  }
}

proc SetFileNumber {msg} {
  set fsys [lindex $msg end]
  .status.fsys config -text "Files in shares: $fsys"

}

proc SetStatus {msg} {
  set fdat [lindex $msg 1]
  set new [lindex $msg 5]
  .status.fdat config -text "Files in database: $fdat"
  .status.new config -text "New files: $new"
}


proc FormatSize { size } {
  set size [lindex $size 0]
  if {$size > 1048576} {
    set size [format "%2.2fMB" [expr $size / 1048576.0]]
  } elseif {$size > 1024} {
    set size [format "%2.2fKB" [expr $size / 1024.0]]
  }
  return $size
}


proc proportion { intero numero } {
 set uno [expr $numero*100]
 set x [expr $uno/$intero]
 return "$x"
}


proc PlayMp3 {filename} {
  global gui me tf
  if {[$gui(play) cget -text]=="PLAY"} {
    if {$filename==""} {
       if {$me(selection)==""} {return}
       if {[$gui(tf) get $me(selection)]==""} {return}
       set index $me(selection)
       if {$index==""} {return}
       set filename "$me(shares)/[lindex [$gui(tf) get $index] 1]"

       if {![file exists $filename]} {
          append filename ".temp"
       }

    }
    if {[catch {open "|$me(player) \"$filename\" 2>@ stderr" r} filech]} {
      tk_messageBox -icon error -message $filech
      return
    }

    fileevent $filech readable "EndPlay $filech"
    $gui(play) configure -text "STOP"

  } else {

    exec killall [file tail $me(player)] &
    $gui(play) configure -text "PLAY"

  }
}

proc EndPlay f {
    global gui
    if {[gets $f line]<0} {
        $gui(play) configure -text "PLAY"
        catch {close $f}
        return
    }
}

proc msg {txt} {
 global gui
 $gui(status) config -state normal
 $gui(status) insert end "$txt\n"
 $gui(status) see end;
 $gui(status) config -state disabled

}


Init
ReadLog

